; Gardens v1.0
; by Thibaut Chevalier 09/07/2001
; la plupart des commentaires sont en franais


coordx              = $f200
coordy              = $f201
cur_jb_pos          = $f202
jb_up_down_bar      = $f203
cur_sequ            = $f204
dont_move           = $f205
draw_cur            = $f206
one_two             = $f207
c_gagn             = $f208
enable_growing      = $f209
out_of_fuel         = $f20a
int_counter         = $f20b
int_counter2        = $f20c
int_counter3        = $f20d
fuel                = $f20e
grass_sum           = $f20f     ; 2 bytes
pixels_for_this_place = $f211
previous_grass_coord = $f212    ; 2 bytes

clipmask            = $f214     ;
rows2put            = $f215     ; PutSprite_MSB variables
bitmask             = $f216     ;

level_no            = $f217
number_of_level     = 10
score               = $f218     ; 2 bytes
max_level_reached   = $f21a

_asm_exec_ram       = $d748
_vputmap            = $4aa1     ; display variable width character (A=char)
int_addr            = $f8f8     ; Start of interrupt code
_runindicoff        = $4ab1
_runindicon         = $4aad
_clrLCD             = $4a7e
_penCol             = $c37c
_vputs              = $4aa5
_pause              = $4d43
_OP1                = $c089
UNPACK_HL           = $4044
GET_KEY             = $5371
K_F5                = $31       ; F5
K_F2                = $34       ; F2
K_F1                = $35       ; F1
K_LEFT              = $02       ; Left
K_RIGHT             = $03       ; Right
K_ENTER             = $09       ; Enter
K_EXIT              = $37       ; exit
K_PLUS              = $0A       ; +
K_MINUS             = $0B       ; -
K_CLEAR             = $0F       ; Clear
K_0                 = $21       ; 0, Y
K_9                 = $14       ; 9, N
_cphlde             = $403C
_SET_ABS_SRC_ADDR   = $4647
_SET_ABS_DEST_ADDR  = $5285
_SET_MM_NUM_BYTES   = $464f
_MM_LDIR            = $52ed
_asapvar            = $0D6FC    ; name of the current asm prog


.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Gardens v1.0 by T. Chevalier",0

ProgStart:
    
;==================== Initialisation =================
    
    call _runindicoff
    call _clrLCD
    res 2,(iy+$23)
    ld hl, max_level_reached
    ld (hl), 1

;==================== Initialisation de l'interruption (mode 2) ================    
    di
    
    ld hl,$FA00                            ;Source = $FA00 (Start of vector table)
    ld de,$FA01                            ;Destination = $FA01
    ld (hl),$F8                            ;Set first byte so it is copied to all of them ($F8F8)
    ld bc,257                              ;257 bytes (size of vector table)
    ldir                                   ;(DE) <- (HL), BC=BC-1, Loop till B=0
 
    ld hl,int_copy                         ;Source = interrupt routine
    ld de,int_addr                         ;Destination = $F8F8 (as specified in vector table)
    ld bc,int_end-int_start                ;Length of custom interrupt routine
    ldir                                   ;(DE) <- (HL), BC=BC-1, Loop till B=0

    ld a,$FA                               ;Set up address of vector table
    ld i,a                                 ; MSB = $FA
                                           ; LSB = (byte supplied by data bus - random)
    jp after_im2_init
 
int_copy:
;====================== Code de l'interruption ====================
int_start:
    ex af,af'                              ;Exchange af with alternate register af'
    exx                                    ;Exchange all other reg's with alternate reg's
    ld hl, int_counter
    ld a, (hl)
    dec a
    ld (hl), a
    jr nz, grass_growing
    ld (hl), 110
    ld a, (fuel)
    ld d, a
    ld e, 127
    call FindPixel
    ld a, %00011100             ; on remplace le bitmask par ceci
    xor (hl)
    ld (hl), a
    inc d
    ld hl, fuel
    ld (hl), d
    ld a, d
    cp 63
    jr nz, grass_growing
    ld hl, out_of_fuel
    ld (hl), 1
grass_growing:
    ld hl, int_counter2
    ld a, (hl)
    dec a
    ld (hl), a
    jr nz, ret_from_int
    ld (hl), 35
    ld bc, (previous_grass_coord)
    call create_random_m2_2
    add a, b                   ; modifie la coordone x (+2, 0 ou -2)
    ld b, a
    call create_random_m2_2
    add a, c                   ; modifie la coordone y (+2, 0 ou -2)
    ld c, a
    ld de, (background_jb)
    call compare_coord          ; contrle si la pelouse repousse sous les jambes du tondeur
    jr c, not_here
    ld de, (background_tond)
    call compare_coord          ; contrle si la pelouse repousse sous la tondeuse
    jr c, not_here
    call count_pixels           ; Compte le nombre de pixels allums avant la pousse de l'herbe
        push hl
    ld (previous_grass_coord), bc
            push bc
    call PutGrass
    ld hl, map
    call DrawLittleMap
            pop bc
    call count_pixels          ; Compte le nombre de pixels allums aprs la pousse de l'herbe
    ld a, l
        pop hl
    sub l                      ; diffrence = nombre de pixels rajouts
    ld hl, (grass_sum)
    ld d, 0
    ld e, a
    add hl, de
    ld (grass_sum), hl
    jr ret_from_int                             
not_here:
    ld hl, int_counter3
    ld a, (hl)
    dec a
    ld (hl), a
    jr nz, ret_from_int
    ld (hl), 4
    call calculate_random_grass_place
ret_from_int:
    jp $66
int_end:

;=================== Fin du code de l'interruption / Routine utilise pendant l'interruption =================

create_random_m2_2:
    ld a, 3
    call Random     ; a = 0, 1 ou 2
    sla a           ; a = 0, 2 ou 4
    sub 2           ; a = -2, 0 ou 2
    ret

compare_coord:
    ld a, b
    cp 6
    jr nz, no_b_left_jet
    ld b, 8
no_b_left_jet:
    cp 108
    jr nz, no_b_right_jet
    ld b, 106
no_b_right_jet:
    ld a, c
    cp 6
    jr nz, no_c_up_jet
    ld c, 8
no_c_up_jet:
    cp 58
    jr nz, no_c_down_jet
    ld c, 56
no_c_down_jet: 
    ld a, e
    sub b
    add a, 9
    cp 16
    jr c, growing_b_not_allowed
    or a
    ret
growing_b_not_allowed:    
    ld a, d
    sub c
    add a, 9
    cp 16
    jr c, growing_c_not_allowed
    or a                        ; reset carry pour montrer OK
    ret
growing_c_not_allowed:
    scf                         ; set carry comme message d'erreur
    ret

calculate_random_grass_place:
    ld a, 49        
    call Random ; 0 <= a < 49
    add a, 4    ; 4 <= a < 53
    sla a       ; 8 <= a < 106 (a pair)0
    ld b, a
    ld a, 21
    call Random ; 0 <= a < 21
    add a, 4    ; 4 <= a < 25 
    sla a       ; 8 <= a < 50 (a pair)
    ld c, a
    ld (previous_grass_coord), bc
    ret

PutGrass;
    push bc
    inc b
    inc c
    ld d, c
    ld e, b
pg_loop:
    call pg_put_line
    dec e
    inc d
    call pg_put_line
    dec e
    dec e
    dec e
    inc d
    call pg_put_line
    dec e
    inc d
    call pg_put_line
    pop bc
    ret
pg_put_line:
    call FindPixel
    or (hl)
    ld (hl), a
    inc e
    inc e
    call FindPixel
    or (hl)
    ld (hl), a
    ret
        
Random:            ; Creates a random number 0 <= x < A
 push bc
 ld b,a
 ld a,r
 add a,a
 ld hl,0
 ld d,0
 ld e,a
RMul:
 add hl,de
 djnz RMul
 ld a,h
 pop bc
 ret

;========================================================
 
;================ Affichage du menu ==================

after_im2_init: 
    ei
    im 1
    ld b, 28
no_double_key:
    halt
    djnz no_double_key
    call _clrLCD
    
    ld b, 26
    ld d, 102
    ld c, 0
    call DrawHoriz  
    ld b, 26
    ld c, 63
    call DrawHoriz
    ld c, 26
    ld b, 0
    call DrawVert
    ld c, 102
    ld b, 0
    call DrawVert
    
    ld a, 14
    ld hl, Gardens_monotype
    ld de, $fc35
put_garden:
    ld bc, 6
    ldir                ; copie une ligne
    push hl
    ld hl, 10
    add hl, de
    ex de, hl           ; passe  la ligne suivante sur la destination (LCD)
    pop hl              ; recupre la source (automatiquement  la ligne suivante)
    dec a
    jr nz, put_garden

    res 3,(iy+$5)       ; texte noir sur fond blanc
    ld bc, (256*16)+46
    ld (_penCol), bc
    ld hl, version_string
    call _vputs
    ld bc, (256*23)+31
    ld (_penCol), bc
    call _vputs         ; hl = my_name_string
    ld bc, (256*33)+35
    ld (_penCol),bc
    call _vputs         ; hl = new_game_string
    ld bc, (256*40)+35
    ld (_penCol),bc
    call _vputs         ; hl = select_level_string
    ld bc, (256*47)+35
    ld (_penCol),bc
    call _vputs         ; hl = exit_string
    ld bc, (256*55)+35
    ld (_penCol),bc
    call _vputs         ; hl = high_score_string
    ld hl, (high_score)
    ld de, 0
    call _cphlde
    jr z, no_high_score
    ld hl, (high_score)
    ld c, 74
    ld (_penCol),bc
    call DisplayHL

no_high_score:     
    set 3,(iy+$5)       ; texte blanc sur fond noir

main_menu_loop:
    call GET_KEY
    cp K_F1
    jp z, new_game 
    cp K_F2
    jr z, level_select
    cp K_F5
    jp z, fin
    cp K_PLUS
    call z, contrast_plus
    cp K_MINUS
    call z, contrast_minus
    cp K_CLEAR
    jr z, clear_high_score
    cp K_EXIT
    jp z, fin
    jr main_menu_loop

clear_high_score:
    call prep_text_place
    ld bc, (256*29)+24
    ld (_penCol), bc
    ld hl, clear_hs_string
    call _vputs
clear_hs_loop:
    call GET_KEY
    cp K_9
    jp z, after_im2_init
    cp K_0
    jr nz, clear_hs_loop
    ld hl, high_score
    ld (hl), 0
    inc hl
    ld (hl), 0
    jp after_im2_init

level_select:
    ld a, 1
    ld (level_no), a
level_select_change:
    ld a, 1
    push af
    jr level_select_inser
level_select_return:
    ld a, (level_no)
    cp 1
    jr z, level_1
    ld bc, 29
    ld hl, arrow_left
    call PutSprite
level_1:
    ld a, (max_level_reached)
    ld b, a
    ld a, (level_no)
    cp b
    jr z, level_select_loop
    ld bc, (256*120)+29
    ld hl, arrow_right
    call PutSprite
level_select_loop:
    call GET_KEY
    cp K_LEFT
    jr z, level_select_left
    cp K_RIGHT
    jr z, level_select_right
    cp K_ENTER
    jr z, level_select_ok
    cp K_PLUS
    call z, contrast_plus
    cp K_MINUS
    call z, contrast_minus
    cp K_EXIT
    jp z, after_im2_init
    jr level_select_loop
level_select_left:
    ld hl, level_no
    ld a, (hl)
    cp 1
    jr z, level_select_loop
    dec a
    ld (hl), a
    jr level_select_change
level_select_right:
    ld a, (max_level_reached)
    ld b, a
    ld hl, level_no
    ld a, (hl)
    cp b
    jr z, level_select_loop
    inc a
    ld (hl), a
    jr level_select_change
level_select_ok:
    ld hl, score
    ld (hl), 0         ; score = 0
    inc hl
    ld (hl), 0
    jp level_select_ok2
    
;================= Initialisation des variables permanentes jeu (execut une seule fois) =================    
new_game:
    ld hl, level_no
    ld (hl), 1          ; debut au level 1
    ld hl, score
    ld (hl), 0         ; score = 0
    inc hl
    ld (hl), 0
;================== Initialisation du niveau (execut a chaque niveau) =================

;------------------ Comptage des pixels de la pelouse ---------------------
    
new_level:
    xor a
    push af
level_select_inser:
    call _clrLCD
    
    ld a, (level_no)
    dec a
    ld b, a 
    ld hl, 0
    jr z, no_mult
    ld de, 128
mult_128:
    add hl, de
    djnz mult_128   ; multiplie a par 128 (largeur d'une map)
no_mult:
    ex de, hl
    ld hl, maps
    add hl, de      ; hl = start of map data (source)
    ld de, map      ; destination
    ld bc, 128
    ldir            ; copie la map du level courant dans la map statique (map)
    
    ld de, map
    ld hl, 0
    ld b, 128
count_grass_pixels_loop:
    push bc
    ld bc, 32
    ld a, (de)
    cp 0
    jr nz, decors_place
    add hl, bc
decors_place:
    pop bc
    inc de
    djnz count_grass_pixels_loop
    ld bc, 256
    or a
    sbc hl, bc
    ld (grass_sum), hl

;------------------ Affichage de la pelouse ---------------------
    
    ld hl, $fc00
    ld b, 32
grassfill0:
    ld c, b
    ld b, 15
grassfill1:
    ld (hl), %10101010
    inc hl
    djnz grassfill1
    inc hl
    ld b, 15
grassfill2:
    ld (hl), %01010101
    inc hl
    djnz grassfill2
    inc hl
    ld b, c
    djnz grassfill0
    ld hl, map
    call DrawMap
    
;------------------ Affichage de la jauge de fuel ----------------------    
    
    ld de, 16
    ld hl, $fc0f
    ld b, 64
fuel_fill_loop:
    ld a, (hl) 
    xor %00111110
    ld (hl), a
    add hl, de
    djnz fuel_fill_loop
    
    ld bc, (256*39)+123
    ld (_penCol),bc
    ld a, 'f'
    call _vputmap
    ld b, 45
    ld (_penCol), bc
    ld a, 'u'
    call _vputmap
    ld b, 51
    ld (_penCol), bc
    ld a, 'e'
    call _vputmap
    ld b, 57
    ld (_penCol), bc
    ld a, 'l'
    call _vputmap

;------------------ Affichage initial du tondeur ----------------    
    
    ;ld bc, (9*256)+1
    ;ld hl, decoupe
    ;ld de, map+128
    ;call PutSprite_MSB
    ;ld hl, map
    ;call DrawLittleMap     ; inutile si la tondeuse est sur un carreau au dbut
    ld hl, background_jb
    ld (hl), 1
    inc hl
    ld (hl), 1
    ld hl, background_tond
    ld (hl), 9
    inc hl
    ld (hl), 1
    ld bc, (1*256)+1 
    ld hl, jb1_droite
    ld de, background_jb+2
    call PutSprite_MSB
    ld bc, (9*256)+1 
    ld hl, tondeuse_droite
    ld de, background_tond+2
    call PutSprite_MSB

;------------------- Affichage du nom du niveau ---------------   

    ld hl, $fdc0
    ld de, map+128+8            ; on sauvegarde la zone de l'affichage crase en map+128+8 (map est une map de 128 bytes et wasted est un sprite de 8*8)
    ld bc, 144
    ldir
    call prep_text_place
    ld hl, string_lenght_start-1
    ld a, (level_no)
    ld c, a                     ; b = 0 aprs un 'ldir'
    add hl, bc
    ld c, (hl)                  ; c = start of this level string - start of level 1 string
    ld hl, levelname_start
    add hl, bc                  ; hl = adresse du string de ce niveau
    ld bc, (256*29)+10
    ld (_penCol), bc
    call _vputs                 ; affiche le nom de niveau

    pop af
    cp 1
    jp z, level_select_return   
    
level_agree_loop:
    call GET_KEY
    cp K_PLUS
    call z, contrast_plus
    cp K_MINUS
    call z, contrast_minus
    cp K_EXIT
    jp z, check_high_score
    cp K_ENTER
    jr nz, level_agree_loop
    
level_select_ok2:
    ld de, $fdc0
    ld hl, map+128+8            ; on rtablit la zone crase
    ld bc, 144
    ldir

;------------------- Initialisation des variables -------------------      
    
    ld hl, coordx   ; coordx = 9
    ld (hl), 9
    inc hl          ; coordy = 1
    ld (hl), 1
    inc hl          ; cur_jb_pos = 1
    ld (hl), 1
    inc hl          ; jb_up_down_bar = 1
    ld (hl), 1
    inc hl          ; cur_sequ = 1
    ld (hl), 1
    ld hl, one_two  ; one_two = 0
    ld (hl), 0
    inc hl          ; c_gagn = 0
    ld (hl), 0
    ld hl, enable_growing  ; enable_growing = 1
    ld (hl), 1      
    inc hl          ; out_of_fuel = 0
    ld (hl), 0
    inc hl          ; int_counter = 110 (pour la descente du fuel)
    ld (hl), 110
    inc hl          ; int_counter2 = 35 (pour l'espacement temporel de la pousse)
    ld (hl), 35
    inc hl          ; int_counter3 = 4
    ld (hl), 4
    inc hl          ; fuel = 0 (range du haut de l'cran)
    ld (hl), 0
    call calculate_random_grass_place   ; previous_grass_coord = random

    ei
    im 2

;================== Fin de l'initialisation du niveau ==================

;================== Boucle d'acquisition des directions ================

getloop:
    ld a, (c_gagn)
    cp 1
    jp z, gagn_ouais
    ld a, (out_of_fuel)
    cp 1
    jp z, out_of_fuel_jump
    
    ld a,%01111110 
    out (1),a
    nop
    nop
    in a,(1)
    bit 2,a
    jr z, droite

    ld a,%01111110
    out (1),a 
    nop
    nop
    in a,(1)
    bit 1,a
    jr z, gauche

    ld a,%01111110
    out (1),a
    nop
    nop
    in a,(1)
    bit 3,a 
    jp z, haut

    ld a,%01111110
    out (1),a
    nop
    nop
    in a,(1)
    bit 0,a
    jp z, bas

    ld a,%00111111
    out (1),a
    nop
    nop
    in a,(1)
    bit 6,a
    jp z, check_high_score

    ld a,%00111111
    out (1),a
    nop
    nop
    in a,(1)
    bit 7,a
    jp z, paused

    jr getloop

;================== Boucles de dplacement dans chacune des directions ==================

droite:  
    halt
    halt
    call retab_fond     ; retablit le fond sans la tondeuse , recupere les anciennes coordonnes b et c
                        ; d = cur direction
    ld (hl), 1          ; save next direction for next loop
    ld e, 1             ; e = next direction
    call sequenseur     ; calcule les nouvelles coordones et les sauvegarde, efface l'herbe
    
    ld hl, tondeuse_droite
    ld de, background_jb+2
    call PutSprite_MSB
    ld a, b
    sub 8
    ld b, a
    ld hl, background_tond
    ld (hl), b
    inc hl
    ld (hl), c
    ld hl, jb1_droite
    ld de, background_tond+2
    ld a, (dont_move)
    cp 1
    call nz, select_1_2_3_4
    call PutSprite_MSB
    jp getloop

gauche:  
    halt
    halt
    call retab_fond     ; retablit le fond sans la tondeuse , recupere les anciennes coordonnes b et c
                        ; d = cur direction
    ld (hl), 2          ; save next direction for next loop
    ld e, 2             ; e = next direction
    call sequenseur     ; calcule les nouvelles coordones et les sauvegarde, efface l'herbe
    
    ld hl, tondeuse_gauche
    ld de, background_jb+2
    call PutSprite_MSB
    ld a, b
    add a, 8
    ld b, a
    ld hl, background_tond
    ld (hl), b
    inc hl
    ld (hl), c
    ld hl, jb1_gauche
    ld de, background_tond+2
    ld a, (dont_move)
    cp 1
    call nz, select_1_2_3_4
    call PutSprite_MSB
    jp getloop

haut:  
    halt
    halt
    call retab_fond     ; retablit le fond sans la tondeuse , recupere les anciennes coordonnes b et c
                        ; d = cur direction
    ld (hl), 3          ; save next direction for next loop
    ld e, 3             ; e = next direction
    call sequenseur     ; calcule les nouvelles coordones et les sauvegarde, efface l'herbe
    
    ld hl, tondeuse_haut
    ld de, background_jb+2
    call PutSprite_MSB
    ld a, c
    add a, 8
    ld c, a
    ld hl, background_tond
    ld (hl), b
    inc hl
    ld (hl), c
    ld hl, jb1_haut
    ld de, background_tond+2
    ld a, (dont_move)
    cp 1
    call nz, select_1_2_3_4
    call PutSprite_MSB
    jp getloop

bas:  
    halt
    halt
    call retab_fond     ; retablit le fond sans la tondeuse , recupere les anciennes coordonnes b et c
                        ; d = cur direction
    ld (hl), 4          ; save next direction for next loop
    ld e, 4             ; e = next direction
    call sequenseur     ; calcule les nouvelles coordones et les sauvegarde, efface l'herbe
    
    ld hl, tondeuse_bas
    ld de, background_jb+2
    call PutSprite_MSB
    ld a, c
    sub 8
    ld c, a
    ld hl, background_tond
    ld (hl), b
    inc hl
    ld (hl), c
    ld hl, jb1_bas
    ld de, background_tond+2
    ld a, (dont_move)
    cp 1
    call nz, select_1_2_3_4
    call PutSprite_MSB
    jp getloop

;================== Routines communes aux quatre directions ==================

select_1_2_3_4:             ; selectionne le bon sprite pour les jambes et gre le va-et-vient
    push bc
    push hl
    ld hl, one_two
    ld a, (hl)
    cp 3
    jr z, one
two:
    inc a
    ld (hl), a
    ld hl, cur_jb_pos
    jr jb_sprite_select
one:
    ld (hl), 0
    ld hl, cur_jb_pos
    ld a, (hl)
    ld hl, jb_up_down_bar
    cp 1
    jr z, down_up_trans
    cp 3
    jr nz, not_up_down_trans
    ld (hl), 0
    jr not_up_down_trans
down_up_trans:
    ld (hl), 1
not_up_down_trans:
    ld a, (hl)
    ld hl, cur_jb_pos
    cp 1
    jr z, up_trans
    dec (hl)
    jr jb_sprite_select
up_trans:
    inc (hl)
jb_sprite_select
    ld a, (hl)
    dec a
    sla a
    sla a
    sla a
    sla a
    ld b, 0
    ld c, a
    pop hl
    add hl, bc
    pop bc
    ret

retab_fond:             ; rtablit le fond sans la tondeuse et le personnage
    ld hl, background_jb
    ld b, (hl)
    inc hl
    ld c, (hl)
    inc hl
    call PutSprite
    ld hl, background_tond
    ld b, (hl)
    inc hl
    ld c, (hl)
    inc hl
    call PutSprite
    ld hl, coordx
    ld b, (hl)
    ld hl, coordy
    ld c, (hl)
    ld hl, cur_sequ
    ld d, (hl)
    ret

sequenseur:     ; d = sequence courante    e = sequence suivante.  Calcule les diffrences sur les coordonnes du sprite "tondeuse" en fonction de l'enchanement des squences (directions)
    dec d
    dec e
    ld a, d
    sla a
    sla a
    sla a
    sla e
    add a, e
    ld d, 0
    ld e, a
    ld hl, sequentiel
    add hl, de
    ld a, b
    add a, (hl)
    ld b, a
    inc hl
    ld a, c
    add a, (hl)
    ld c, a
    ld hl, dont_move
    ld (hl), 0
;--- Contrle si la tondeuse sort de l'cran ---
    rla
    jr nc, no_upper
    call set_dont_move
    ld c, 0
no_upper:
    ld a, c
    cp 55
    jr c, no_under
    call set_dont_move
    ld c, 55
no_under:
    ld a, b
    rla
    jr nc, not_on_left
    call set_dont_move
    ld b, 0
not_on_left:
    ld a, b
    cp 111
    jr c, not_on_right
    call set_dont_move
    ld b, 111
not_on_right
;-----------------------------------------------    
    im 1                    ; dsactive l'interruption pour ne pas qu'elle influe sur grass_sum 
    call count_pixels       ; Compte le nombre de pixels allums avant le coupage de l'herbe
        push hl
    ld hl, coordx
    ld (hl), b
    ld hl, coordy
    ld (hl), c
    ld hl, decoupe
    ld de, map+128
    call PutSprite_MSB      ; efface l'herbe
            push bc
    ld hl, map
    call DrawLittleMap      ; redessine le dcor autour de la tondeuse pour ne pas qu'il ne soit "tondu"
            pop bc
    call count_pixels       ; Compte le nombre de pixels allums aprs le coupage de l'herbe
    ld d, l
        pop hl
    ld a, l
    sub d
    ld hl, (grass_sum)
    ld d, 0
    ld e, a
    or a
    sbc hl, de
    ld (grass_sum), hl
    jr nz, dont_win    
    ld hl, c_gagn
    ld (hl), 1
dont_win:
    im 2                    ; ractive l'interruption  
    ld hl, background_jb
    ld (hl), b
    inc hl
    ld (hl), c
    ret

set_dont_move:
    ld hl, dont_move
    ld (hl), 1
    ret

;===================== Autres routines, pause, fin du jeu... ========================

count_pixels:
    push bc
    ld e, b
    ld d, c
    ld l, 0
   
    ld b, 6
cp_loop_vert:
    inc d
        push de
            push bc
    ld b, 6
cp_loop_horiz:
    push hl
    inc e
    call FindPixel
    and (hl)        ; garde uniquement le pixel selectionn
    cp 0
    pop hl
    jr z, pixel_off
    inc l
pixel_off:
    djnz cp_loop_horiz
            pop bc
        pop de
    djnz cp_loop_vert
    pop bc
    ret

paused:
    ld hl, $fdc0
    ld de, map+128+8
    ld bc, 144
    ldir
    im 1                ; dsactive l'interruption
    call prep_text_place
    set 3,(iy+5)        ; texte blanc sur fond noir
    ld bc, (256*29)+48
    ld (_penCol), bc
    ld hl, paused_string
    call _vputs

pause_loop:
    call GET_KEY
    cp K_PLUS
    call z, contrast_plus
    cp K_MINUS
    call z, contrast_minus
    cp K_EXIT
    jp z, check_high_score
    cp K_ENTER
    jr nz, pause_loop    

    ld de, $fdc0
    ld hl, map+128+8
    ld bc, 144
    ldir
    im 2                ; ractive l'interruption
    jp getloop

out_of_fuel_jump:
    im 1                ; desactive l'interruption
    call prep_text_place
    set 3,(iy+5)        ; texte blanc sur fond noir
    ld bc, (256*29)+45
    ld (_penCol), bc
    ld hl, out_of_fuel_string
    call _vputs
    call _pause
    jp check_high_score

gagn_ouais:
    im 1
    call prep_double_text_place
    set 3,(iy+5)        ; texte blanc sur fond noir
    ld bc, (256*25)+44
    ld (_penCol), bc
    ld hl, level_done_string
    call _vputs
    ld bc, (256*33)+44
    ld (_penCol), bc
    ld hl, score_string
    call _vputs
    
    ld bc, (256*33)+68
    ld (_penCol), bc
    ld hl, (score)
    call DisplayHL
    
    ld b, 200
wait_pack:
    halt
    djnz wait_pack
    
    ld a, (fuel)
    ld d, a
    ld hl, (score)
score_inc_continue_loop:
    ld b, 10
score_inc_wait_loop:
    halt
    djnz score_inc_wait_loop
    push hl
    ld e, 127
    call FindPixel
    ld a, (hl)
    cp %11111111            ; si sous l'une des bandes noires
    jr z, under_text        ; saute le xor
    cp %00000000            ; si sous l'une des bandes blanche
    jr z, under_text        ; saute le xor
    ld a, %00011100         ; on remplace le bitmask par ceci
    xor (hl)
    ld (hl), a
under_text:
    inc d
    pop hl
        push de
    ld bc, 10
    add hl, bc
            push hl
    ld bc, (256*33)+68
    ld (_penCol), bc
    ld (score), hl
    call DisplayHL
            pop hl
        pop de
    ld a, d
    cp 63
    jr nz, score_inc_continue_loop
    call _pause
    ld hl, level_no
    ld a, (hl)
    inc a
    ld (hl), a
    ld hl, max_level_reached
    ld b, (hl)
    cp b
    jr c, inferior_to_the_max   ; ne change pas 'max_level_reached' si le niveau est infrieur
    cp number_of_level+1
    jr z, inferior_to_the_max   ; ne change pas 'max_level_reached' si c'est le dernier niveau
    ld (max_level_reached), a
inferior_to_the_max:
    cp number_of_level+1
    jp nz, new_level
    ld bc, (256*25)+44
    ld (_penCol), bc
    ld hl, final_score_string
    call _vputs
    call _pause
    
check_high_score:
    im 1
    ld hl, (score)
    ld de, (high_score)
    call _cphlde
    jp z, after_im2_init
    jp c, after_im2_init   ; pas de nouveau high_score 
    call prep_double_text_place
    ld bc, (256*25)+36
    ld (_penCol), bc
    ld hl, new_high_score_string
    call _vputs
    ld bc, (256*33)+44
    ld (_penCol), bc
    ld hl, score_string
    call _vputs
    ld bc, (256*33)+68
    ld (_penCol), bc
    ld hl, (score)
    
    ld (high_score), hl
    call DisplayHL
    call _pause
    jp after_im2_init


prep_text_place:    ; dessine une bande noire au milieu de l'cran
    ld hl, $fdc0
    ld de, $fdc1
    ld (hl), $00 
    ld bc, 143
    ldir
    ld hl, $fdd0
    ld de, $fdd1
    ld (hl), $ff 
    ld bc, 111
    ldir
    ret
prep_double_text_place:     ; dessine deux bandes noires au milieu de l'cran
    ld hl, $fd80
    ld de, $fd81
    ld (hl), $00 
    ld bc, 271
    ldir
    ld hl, $fd90
    ld de, $fd91
    ld (hl), $ff 
    ld bc, 111
    ldir
    ld hl, $fe10
    ld de, $fe11
    ld (hl), $ff 
    ld bc, 111
    ldir
    ret

contrast_plus:
    push af
    ld a, ($C008)   ; recupre la valueur du contraste
    inc a           ; l'incremente
    ld ($C008), a   ; la sauvegarde
    out (2), a      ; envoie la nouvelle valeur au port 2 (qui gre le contraste) : $C008 est juste une valeur image de contrast
    pop af
    ret

contrast_minus:
    push af
    ld a, ($C008)   ; c'est la mme chose
    dec a
    ld ($C008), a
    out (2), a
    pop af
    ret
    
; ================= Sortie du programme =================

fin:
    res 3,(iy+$5)       ; texte noir sur fond blanc
    im 1
    res 2,(iy+$23)      ; dsactive l'interruption (im1)
    
save_data:
    ld hl,_asapvar      ;hl->name of program
    rst 20h             ;copy to OP1
    rst 10h             ;_findsym
    xor a
    ld hl,data_start-_asm_exec_ram+4        ;offset
    add hl,de                   ;hl=pointer to data in original prog
    adc a,b                     ;in case we overlapped pages
    call _SET_ABS_DEST_ADDR
    xor a                       ;no absolute addressing now
    ld hl,data_start            ;get data from here
    call _SET_ABS_SRC_ADDR
    ld hl,data_end-data_start   ;number of bytes to save
    call _SET_MM_NUM_BYTES
    call _MM_LDIR               ;copy data

    call _clrLCD        ; efface l'cran
    call _runindicon    ; ractive le "run indicator"
    ret


;=================== Routines ====================

#include "ascr.h"

;====================================================================
; DisplayHL:  (idea from SCaBBy/Mardell)    [Assembly Coder's Zenith]
;  Display HL as a 5-digit decimal number with no leading zeros
;  out: AF, HL, BC, DE destroyed
;====================================================================
DisplayHL:
 ld c,'0'           ; save ascii value for zero
 ld de,_OP1+5           ; point to end of the buffer
 xor a              ; zero terminate string
 ld (de),a          ; set last byte to zero
DisplayHLl:
 call UNPACK_HL         ; next digit
 dec de             ; next position
 add a,c            ; convert to ascii
 ld (de),a          ; save digit
 ld a,h             ; load upper byte
 or l               ; check with lower byte for zero
 jr nz,DisplayHLl       ; loop
 ex de,hl           ; point to buffer
 call _vputs            ; print number
 ret                ; we're done

; =============================================================
; Draw a line between points (c,b) and (c,d)
; =============================================================
DrawVert:
    push bc
    push de
    ld e, c
    ld d, b
    call FindPixel
    or (hl)            
    ld (hl), a
    pop de
    pop bc
    ld a, b
    cp d
    ret z
    inc b
    jr DrawVert

; =============================================================
; Draw a line between points (b,c) and (d,c)
; =============================================================
DrawHoriz:
    push bc
    push de
    ld e, b
    ld d, c
    call FindPixel
    or (hl)            
    ld (hl), a
    pop de
    pop bc
    ld a, b
    cp d
    ret z
    inc b
    jr DrawHoriz


; =============================================================
; Dan Eble & James Yopp FindPixel routine
; Input:  D = y, E = x
; Output: HL= addr in vid mem, A = bitmask, C is modified
; =============================================================
FindPixel:
        ld hl,FP_Bits
        ld a,e
        and $07         ; a = bit offset
        add a,l
        ld l,a
        adc a,h
        sub l
        ld h,a
        ld c,(hl)       ; c = bitmask for (hl)
            ;48 t-states up to this point
        ld hl,FP_RLD
        ld (hl),d
        ld a,e          ; a = x/8 (byte offset within row)
        rrca
        rrca   
        rrca
        rld
        or $FC 
        ld l,(hl)
        ld h,a          ; hl -> byte in vid mem
        ld a,c          ; now a = bitmask for (hl)
;121 t-states up to this point
        ret

FP_RLD:  .db $00
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01


;============================================================
; DrawMap -- draws an 8x16 tilemap  [Assembly Coder's Zenith]
;  input: HL = pointer to tilemap to draw
;  total: 34b/91529t (including ret and entire GridPutSprite)
;============================================================
DrawMap:
 ld de,$0000            ; start drawing at (0, 0)
DrawMapL:
 push hl                ; save map pointer
 ld l,(hl)              ; get the current tile
 ld a, l
 cp 0
 jr z, DrawMapT 
 dec l
 ld h,0                 ; clear the upper byte
 add hl,hl              ; multiply by 8 (* 2)
 add hl,hl              ; * 4
 add hl,hl              ; * 8
 ld bc,Sprites          ; load the start of the sprites
 add hl,bc              ; add togehter to get correct sprite
 push de                ; save sprite draw location
 call GridPutSprite     ; draw the sprite
 pop de                 ; restore sprite draw location
DrawMapT:
 pop hl                 ; restore map pointer
 inc hl                 ; go to next tile
 inc e                  ; move location to the right
 bit 4,e                ; if the 5th bit (e = 16), we're done
 jr z,DrawMapL          ; only jump if the row isn't complete
 ld e,0                 ; draw at the left again
 inc d                  ; move location down a row
 bit 3,d                ; check if it's done (e = 8)
 ret nz                 ; return if we're done
 jr DrawMapL            ; jump back to the top of the loop


;=====================================================================
; DrawLittleMap - draws an 2x2 tilemap in order to cover a 8*8 sprite 
;  input: HL = pointer to tilemap to draw
;         (b,c) = coordonate of 8*8 sprite to cover 
;=====================================================================
DrawLittleMap:
 push hl
 ld hl, draw_cur
 ld (hl), 0
 pop hl
 ld a, b
 and %01111111
 ld e, a
 ld a, c
 and %00111111
 ld d, a
 srl d
 srl d
 srl d
 srl e
 srl e
 srl e
 and $f8
 sla a
 add a, e
 ld b, 0
 ld c, a
 add hl, bc
DrawLittleMapL:
 push hl                ; save map pointer
 ld l,(hl)              ; get the current tile
 ld a, l
 cp 0
 jr z, DrawLittleMapT 
 dec l
 ld h,0                 ; clear the upper byte
 add hl,hl              ; multiply by 8 (* 2)
 add hl,hl              ; * 4
 add hl,hl              ; * 8
 ld bc,Sprites          ; load the start of the sprites
 add hl,bc              ; add togehter to get correct sprite
 push de                ; save sprite draw location
 call GridPutSprite     ; draw the sprite
 pop de                 ; restore sprite draw location
DrawLittleMapT:
 ld hl, draw_cur
 ld a, (hl)
 inc a
 ld (hl), a
 dec a
 pop hl
 bit 0, a
 jr nz, DrawLittleMapN
 inc hl
 inc e
 jr DrawLittleMapL
DrawLittleMapN:
 inc d
 dec e
 ld bc, 15
 add hl, bc
 cp 3
 ret z
 jr DrawLittleMapL

;===========================================================
; GridPutSprite:                                  [Dan Eble]
;  Puts an aligned sprite at (E, D), where HL -> Sprite
;===========================================================
; IN : D  = y (0-7 inclusive)
;      E  = x (0-15 inclusive)
;      HL-> sprite
;
; OUT: AF, BC, DE, HL, IX modified
; Current total : 28b/567t (not counting ret)
;===========================================================
GridPutSprite:
 push hl
 pop ix                 ; ix-> sprite
 srl d                  ; de = 128y+x (16 bytes/row, 8 rows)
 rra
 and $80
 or e                   ; add x offset (remember x <= 15)
 ld e,a
 ld hl,$fc00            ; hl-> video ram
 add hl,de              ; hl-> video ram + offset
 ld b,8                 ; initialize loop counter
 ld de,$10              ; initialize line increment
GPS_Loop
 ld a,(ix+0)            ; get byte from sprite
 ld (hl),a              ; put byte on screen
 inc ix                 ; move to next byte in sprite
 add hl,de              ; move to next line on screen
 djnz GPS_Loop
 ret


;=================== Sprites, tilemaps ==================

sequentiel: .db 1,0,0,0,0,252,0,4       ; tableau utilis dans la routine "sequenseur"
            .db 0,0,255,0,0,252,0,4
            .db 4,0,252,0,0,255,0,0
            .db 4,0,252,0,0,0,0,1


maps:
map01:
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0
 .db 3,5,5,5,5,5,5,5,5,5,5,5,5,5,3,0
 .db 3,5,1,1,1,1,1,1,1,1,1,1,1,5,3,0
 .db 3,5,1,0,0,0,0,0,0,0,0,0,1,5,3,0
 .db 3,5,1,0,0,0,0,0,0,0,0,0,1,5,3,0
 .db 3,5,1,1,1,1,1,1,1,1,1,1,1,5,3,0
 .db 3,5,5,5,5,5,5,5,5,5,5,5,5,5,3,0
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0

map02:
 .db 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0
 .db 2,6,6,6,6,6,6,2,6,6,6,6,6,6,2,0
 .db 2,6,0,0,0,0,6,2,6,0,0,0,0,6,2,0
 .db 2,6,0,0,0,0,6,2,6,0,0,0,0,6,2,0
 .db 2,6,0,0,0,0,6,2,6,0,0,0,0,6,2,0
 .db 2,6,0,0,0,0,6,2,6,0,0,0,0,6,2,0
 .db 2,6,6,6,6,6,6,2,6,6,6,6,6,6,2,0
 .db 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0

map03:
 .db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0
 .db 4,6,6,0,0,0,0,0,0,0,0,0,6,6,4,0
 .db 4,6,6,1,1,1,1,1,1,1,1,1,6,6,4,0
 .db 4,0,0,0,0,1,1,1,1,1,0,0,0,0,4,0
 .db 4,0,0,0,0,1,1,1,1,1,0,0,0,0,4,0
 .db 4,6,6,1,1,1,1,1,1,1,1,1,6,6,4,0
 .db 4,6,6,0,0,0,0,0,0,0,0,0,6,6,4,0
 .db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0

map04:
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0
 .db 3,0,0,0,5,5,0,5,7,7,7,5,0,0,3,0
 .db 3,0,0,5,0,0,5,0,5,7,7,5,0,0,3,0
 .db 3,5,5,5,0,0,5,5,0,5,5,0,5,5,3,0
 .db 3,5,5,0,5,5,0,5,5,0,0,5,5,5,3,0
 .db 3,0,0,5,7,7,5,0,5,0,0,5,0,0,3,0
 .db 3,0,0,5,7,7,7,5,0,5,5,0,0,0,3,0
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0

map05:
 .db 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0
 .db 6,0,0,0,1,0,0,0,0,0,1,0,0,0,6,0 
 .db 6,0,0,1,0,1,0,0,0,1,0,1,0,0,6,0 
 .db 6,0,1,0,0,0,1,2,1,0,0,0,1,0,6,0
 .db 6,1,0,0,0,1,2,2,2,1,0,0,0,1,6,0 
 .db 6,0,1,0,1,2,2,2,2,2,1,0,1,0,6,0 
 .db 6,0,0,1,2,2,2,2,2,2,2,1,0,0,6,0
 .db 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0 
 
map06:
 .db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0
 .db 4,5,5,5,0,0,0,0,0,0,0,5,5,5,4,0
 .db 4,0,0,7,0,0,1,0,1,0,0,7,0,0,4,0
 .db 4,0,0,8,0,1,0,0,0,1,0,8,0,0,4,0
 .db 4,0,0,8,0,1,0,0,0,1,0,8,0,0,4,0
 .db 4,0,0,7,0,0,1,0,1,0,0,7,0,0,4,0
 .db 4,5,5,5,0,0,0,0,0,0,0,5,5,5,4,0
 .db 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0

map07:
 .db 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0
 .db 2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0
 .db 2,0,6,6,0,0,0,5,0,0,0,6,6,0,2,0
 .db 2,0,6,0,0,0,5,5,5,5,0,0,6,0,2,0
 .db 2,0,6,0,0,5,5,5,5,0,0,0,6,0,2,0
 .db 2,0,6,6,0,0,0,5,0,0,0,6,6,0,2,0
 .db 2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0
 .db 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0 

map08:
 .db 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0
 .db 6,0,0,0,0,0,0,5,0,0,0,0,0,0,6,0
 .db 6,0,0,5,0,0,0,5,0,0,0,5,0,0,6,0
 .db 6,0,5,7,5,0,0,5,0,0,5,7,5,0,6,0
 .db 6,0,0,5,0,0,5,7,5,0,0,5,0,0,6,0
 .db 6,0,0,5,0,0,0,5,0,0,0,5,0,0,6,0
 .db 6,0,0,5,0,0,0,0,0,0,0,5,0,0,6,0
 .db 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0
  
map09:
 .db 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0
 .db 5,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0
 .db 5,1,1,1,0,0,0,0,0,1,1,1,0,0,5,0
 .db 5,0,0,1,0,0,0,0,1,1,0,1,1,1,5,0
 .db 5,0,0,1,1,1,1,0,1,0,0,1,0,0,5,0
 .db 5,0,0,0,0,0,1,1,1,0,0,1,0,0,5,0
 .db 5,0,0,0,0,0,0,0,0,0,0,1,0,0,5,0
 .db 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0    
      
map10:
 .db 1,2,5,6,7,1,2,5,6,7,1,2,5,6,7,0
 .db 7,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0
 .db 6,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0
 .db 5,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0
 .db 2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0
 .db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0
 .db 2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0
 .db 1,7,6,5,2,1,7,6,5,2,1,7,6,5,2,0

Sprites:
cross:        
        .db %00000000
        .db %00100100
        .db %01011010
        .db %00100100
        .db %00100100
        .db %01011010
        .db %00100100
        .db %00000000

fatman:  
        .db %00000000
        .db %01100110
        .db %00011000
        .db %01100110
        .db %01100110
        .db %00011000
        .db %01100110
        .db %00000000

b&w:
        .db %00110011
        .db %00110011
        .db %11001100
        .db %11001100
        .db %00110011
        .db %00110011
        .db %11001100
        .db %11001100

big_circle:
        .db %00011000
        .db %01111110
        .db %01100110
        .db %11000011
        .db %11000011
        .db %01100110
        .db %01111110
        .db %00011000

corners:
        .db %00000000
        .db %01100110
        .db %01000010
        .db %00000000
        .db %00000000
        .db %01000010
        .db %01100110
        .db %00000000

rotated_square:
        .db %00000000
        .db %00110000
        .db %00111110
        .db %00100110
        .db %01100100
        .db %01111100
        .db %00001100
        .db %00000000

circle:
        .db %00000000
        .db %00111100
        .db %01100110
        .db %01000010
        .db %01000010
        .db %01100110
        .db %00111100
        .db %00000000

stairs:        
        .db %01111111
        .db %01010101
        .db %01010101
        .db %01010101
        .db %01010101
        .db %01010101
        .db %01010101
        .db %01111111


background_jb:
.db 0, 0
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101

background_tond:
.db 0, 0
.db %10101010
.db %00000001
.db %10000000
.db %00000001
.db %10000000
.db %00000001
.db %10000000
.db %01010101

tondeuse_droite:
.db %00000000
.db %00110110
.db %11111110
.db %00100001
.db %00100001
.db %11111110
.db %00110110
.db %00000000
.db %00000000
.db %01111110
.db %11111110
.db %11111111
.db %11111111
.db %11111110
.db %01111110
.db %00000000

jb1_droite:
.db %00000000
.db %00000000
.db %01111110
.db %00100101
.db %00100101
.db %00011110
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01111110
.db %00111111
.db %00111111
.db %00011110
.db %00000000
.db %00000000

jb2_droite:
.db %00000000
.db %00000000
.db %00011110
.db %00100101
.db %00100101
.db %00011110
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011110
.db %00111111
.db %00111111
.db %00011110
.db %00000000
.db %00000000

jb3_droite:
.db %00000000
.db %00000000
.db %00011110
.db %00100101
.db %00100101
.db %01111110
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011110
.db %00111111
.db %00111111
.db %01111110
.db %00000000
.db %00000000

tondeuse_gauche:
.db %00000000
.db %01101100
.db %01111111
.db %10000100
.db %10000100
.db %01111111
.db %01101100
.db %00000000
.db %00000000
.db %01111110
.db %01111111
.db %11111111
.db %11111111
.db %01111111
.db %01111110
.db %00000000

jb1_gauche:
.db %00000000
.db %00000000
.db %01111110
.db %10100100
.db %10100100
.db %01111000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01111110
.db %11111100
.db %11111100
.db %01111000
.db %00000000
.db %00000000

jb2_gauche:
.db %00000000
.db %00000000
.db %01111000
.db %10100100
.db %10100100
.db %01111000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01111000
.db %11111100
.db %11111100
.db %01111000
.db %00000000
.db %00000000

jb3_gauche:
.db %00000000
.db %00000000
.db %01111000
.db %10100100
.db %10100100
.db %01111110
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01111000
.db %11111100
.db %11111100
.db %01111110
.db %00000000
.db %00000000

tondeuse_haut:
.db %00011000
.db %01100110
.db %01100110
.db %00100100
.db %01100110
.db %01111110
.db %00100100
.db %00100100
.db %00011000
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %00111100

jb1_haut:
.db %00011000
.db %00100100
.db %00111100
.db %00100100
.db %00100100
.db %00111000
.db %00100000
.db %00000000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00111100
.db %00111000
.db %00100000
.db %00000000

jb2_haut:
.db %00011000
.db %00100100
.db %00111100
.db %00100100
.db %00100100
.db %00011000
.db %00000000
.db %00000000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00111100
.db %00011000
.db %00000000
.db %00000000

jb3_haut:
.db %00011000
.db %00100100
.db %00111100
.db %00100100
.db %00100100
.db %00011100
.db %00000100
.db %00000000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00111100
.db %00011100
.db %00000100
.db %00000000

tondeuse_bas:
.db %00100100
.db %00100100
.db %01111110
.db %01100110
.db %00100100
.db %01100110
.db %01100110
.db %00011000
.db %00111100
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %00011000

jb1_bas:
.db %00000000
.db %00100000
.db %00111000
.db %00100100
.db %00100100
.db %00111100
.db %00100100
.db %00011000
.db %00000000
.db %00100000
.db %00111000
.db %00111100
.db %00111100
.db %00111100
.db %00111110
.db %00011000

jb2_bas:
.db %00000000
.db %00000000
.db %00011000
.db %00100100
.db %00100100
.db %00111100
.db %00100100
.db %00011000
.db %00000000
.db %00000000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00111100
.db %00011000

jb3_bas:
.db %00000000
.db %00000100
.db %00011100
.db %00100100
.db %00100100
.db %00111100
.db %00100100
.db %00011000
.db %00000000
.db %00000100
.db %00011100
.db %00111100
.db %00111100
.db %00111100
.db %00111100
.db %00011000

decoupe:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %00000000

arrow_left:
.db %11111111
.db %11101111
.db %11001111
.db %10001111
.db %11001111
.db %11101111
.db %11111111
.db %00000000

arrow_right:
.db %11111111
.db %11110111
.db %11110011
.db %11110001
.db %11110011
.db %11110111
.db %11111111
.db %00000000

Gardens_monotype:
.db %00000000, %00000000, %00000000, %00001110, %00000000, %00000000
.db %00000000, %00000000, %00000000, %00010000, %00000000, %00000000
.db %00001111, %00000000, %00000000, %00010000, %00000000, %00000000
.db %00110000, %10000000, %00000000, %00100000, %00000000, %00000000
.db %01100000, %10000111, %00010110, %11100001, %10011011, %10001100
.db %01000000, %00011010, %01111001, %00100010, %01101100, %10010010
.db %11000000, %00100010, %00110010, %00100100, %10001001, %00010000
.db %11000111, %10100010, %00100010, %00100111, %00011001, %00001100
.db %11000011, %00100100, %00100110, %11000100, %10010010, %10100100
.db %01100110, %00111111, %01000111, %01110111, %00010011, %00011000
.db %00011010, %00000000, %00000000, %00000000, %00000000, %00000000
.db %00000110, %00000000, %00000000, %00000000, %00000000, %00000000
.db %01000100, %00000000, %00000000, %00000000, %00000000, %00000000
.db %00111000, %00000000, %00000000, %00000000, %00000000, %00000000

;=================== Strings ====================

version_string: .db "version 1.0", 0
my_name_string: .db "by Thibaut Chevalier",0
new_game_string: .db "F1 - New Game", 0
select_level_string: .db "F2 - Select Level", 0
exit_string: .db "F5 - Exit", 0
high_score_string: .db "High Score : -", 0
clear_hs_string: .db "Clear High Score ? (Y/N)", 0

out_of_fuel_string: .db "Out of fuel !", 0 
level_done_string: .db "Level done !", 0
score_string: .db "Score :", 0
paused_string: .db "- Paused -", 0
final_score_string: .db "Final Score", 0
new_high_score_string: .db "New High Score !", 0

string_lenght_start: .db 0,24,51,78,104,129,150,172,195,226
levelname_start:
level1_string: .db "Level 1 : Little Garden", 0
level2_string: .db "Level 2 : Symetric Gardens", 0
level3_string: .db "Level 3 : Miniature Garden", 0
level4_string: .db "Level 4 : Bouncing Garden", 0
level5_string: .db "Level 5 : Pyramid Garden", 0
level6_string: .db "Level 6 : Versailles", 0
level7_string: .db "Level 7 : Hook Garden", 0
level8_string: .db "Level 8 : Arrow Garden", 0
level9_string: .db "Level 9 : Path trough a Garden", 0
level10_string: .db "Level 10 : Mosaic Garden", 0

high_score:
data_start: .dw $0000
data_end

;=================== Zone de sauvegarde de donnes temporaire (largeur = 128+8+144 = 280) ==================
map:
.end
